.686
	
.model flat, stdcall
	
option casemap: none
	
	include \masm32\include\windows.inc
	
	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	llkbdproc proto
	
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\user32.lib
	includelib MKHook.lib
	
.radix 16
	
.data
	
	wcname db "Mouse Keys", 0
	wc WNDCLASSEX <sizeof WNDCLASSEX, 0, offset wndproc, 0, 0, 0, 0, 0, 0, 0, offset wcname, 0>
	
	wtitle db "Mouse Keys", 0
	wmsg MSG <>
	
	dllname db "MKHook.dll", 0
	keyhook dword 0
	
.code
	
wndproc proc hwnd:dword, msg:dword, wpar:dword, lpar:dword
	
	.if [msg] == WM_CREATE
		
		invoke GetModuleHandle, addr dllname
		invoke SetWindowsHookEx, WH_KEYBOARD_LL, addr llkbdproc, eax, 0
		
		.if eax == 0
			
			not eax
			
		.else
			
			mov [keyhook], eax
			xor eax, eax
			
		.endif
		
	.elseif [msg] == WM_DESTROY
		
		.if [keyhook] != 0
			
			invoke UnhookWindowsHookEx, [keyhook]
			
		.endif
		
		invoke PostQuitMessage, 0
		xor eax, eax
		
	.else
		
		invoke DefWindowProc, [hwnd], [msg], [wpar], [lpar]
		
	.endif
	
	ret
	
wndproc endp
	
start:
	
	invoke GetModuleHandle, 0
	mov [wc.hInstance], eax
	
	invoke RegisterClassEx, addr wc
	
	invoke CreateWindowEx, 0, addr wcname, addr wtitle, 0, 0, 0, 10, 10, 0, 0, [wc.hInstance], 0
	
	.while 1
		
		invoke GetMessage, addr wmsg, 0, 0, 0
		
		.if eax == 0
			
			invoke ExitProcess, eax
			
		.endif
		
		invoke DispatchMessage, addr wmsg
		
	.endw
	
end start