.686
	
.model flat, stdcall
	
option casemap: none
	
	include \masm32\include\windows.inc
	
	include \masm32\include\user32.inc
	
	includelib \masm32\lib\user32.lib
	
	MOUSEINPUT struct
		
		_dx dword ?
		dy dword ?
		mouseData dword ?
		dwFlags dword ?
		time dword ?
		dwExtraInfo dword ?
		
	MOUSEINPUT ends
	
	INPUT struct
		
		_type dword ?
		mi MOUSEINPUT <?>
		
	INPUT ends
	
.radix 16
	
.data
	
	mouse_input INPUT <INPUT_MOUSE>
	
.code
	
llkbdproc:
	
	.if dword ptr [esp + 4] == HC_ACTION
		
		mov ecx, [esp + 0C]
		
		mov eax, [ecx + 8]
		
		.if eax & LLKHF_EXTENDED
			
			mov edx, [ecx]
			
			and eax, LLKHF_UP
			.if zero?
				
				sub edx, 2E
				jb cnh
				jnz @F
					
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_RIGHTDOWN
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				sub edx, 32
				jb cnh
				jnz @F
					
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTDOWN
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					inc eax
					dec edx
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], edx
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					inc eax
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], edx
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					inc eax
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					dec eax
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], edx
					jmp mke
			@@:	
				dec edx
				jz cnh
				
				dec edx
				jnz @F
					
					inc eax
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], edx
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					dec eax
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					dec eax
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], edx
					mov [mouse_input.mi.dy], eax
					jmp mke
			@@:	
				dec edx
				jnz @F
					
					inc eax
					dec edx
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MOVE
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], edx
					jmp mke
			@@:	
				sub edx, 2
				jnz cnh
					
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MIDDLEDOWN
					mov [mouse_input.mi._dx], eax
					mov [mouse_input.mi.dy], eax
					jmp mke
				
			.else
				
				sub edx, 2E
				jb cnh
				jnz @F
					
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_RIGHTUP
					mov [mouse_input.mi._dx], edx
					mov [mouse_input.mi.dy], edx
					jmp mke
			@@:	
				sub edx, 32
				jb cnh
				jnz @F
					
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_LEFTUP
					mov [mouse_input.mi._dx], edx
					mov [mouse_input.mi.dy], edx
					jmp mke
			@@:	
				sub edx, 0B
				jnz cnh
					
					mov [mouse_input.mi.dwFlags], MOUSEEVENTF_MIDDLEUP
					mov [mouse_input.mi._dx], edx
					mov [mouse_input.mi.dy], edx
					jmp mke
				
			.endif
			
		.endif
		
	.endif
	
cnh:
	push [esp]
	jmp CallNextHookEx
	
mke:
	mov eax, [ecx + 0C]
	mov [mouse_input.mi.time], eax
	
	invoke SendInput, 1, addr mouse_input, sizeof INPUT
	ret 0C
	
end llkbdproc